//**** A P P L I C A T I O N   N O T E *************************************
//*
//* Title:               AVR-FPGA Interface Design #6
//* Version:             1.1
//* Last Updated:        October 8, 2001
//* Target:              AT94K05/10/40
//*
//* Support Hotline:     +1 (408) 436-4119
//* Support Email:       fpslic@atmel.com
//*
//**************************************************************************

module counter2 (clock, reset, enable, load, awe, d, q, rco);

input        clock;
input        reset;
input        enable;
input        load;
input        awe;
input  [7:0] d;

output [7:0] q;
output       rco;

reg    [7:0] q;
reg          rco;

always @ (posedge clock)
    if (reset == 1'b1)
        begin
            q   <= #1 8'b0;                     // Initialize Q = $00
            rco <= #1 1'b0;                     // Initialize RCO = $01
        end
    else
        if (enable == 1'b1)
            if ((load == 1'b1) && (awe == 1'b1))
                q <= #1 d;                      // Assign D to Q
            else
                if (q != 8'b00011111)
                    begin
                        q   <= #1 q + 1'b1;     // Increment Q by $01
                        rco <= 1'b1;            // Assign RCO = $01
                    end
                else
                    rco <= #1 1'b0;             // Assign RCO = $00
endmodule