//**** A P P L I C A T I O N   N O T E *************************************
//*
//* Title:               AVR-FPGA Interface Design #6
//* Version:             1.1
//* Last Updated:        October 8, 2001
//* Target:              AT94K05/10/40
//*
//* Support Hotline:     +1 (408) 436-4119
//* Support Email:       fpslic@atmel.com
//*
//**************************************************************************

module counter3 (clock, reset, enable, load1, load2, awe, d1, d2,
                 q1, q2, rco1, rco2, ramaddr, ramclk, we);


input         clock;
input         reset;
input         enable;
input         load1, load2;
input         awe;
input  [ 7:0] d1, d2;

output [ 7:0] q1, q2;
output        rco1, rco2;
output [15:0] ramaddr;
output        ramclk;
output        we;

reg    [15:0] ramaddr;
reg           we;

reg    [ 7:0] rData;


assign ramclk = clock;                              // Assign SRAM Clock

always @ (posedge clock)
    begin
        ramaddr <= #1 16'b0000111110011100;         // Assign SRAM Address = $0F9B
        we      <= #1 1'b0;                         // Disable SRAM Write Enable
        rData   <= #1 d2;                           // Assign SRAM Data to rData
    end

counter C0                                          // Instantiate First Counter
            (
                .clock(clock),
                .reset(reset),
                .enable(enable),
                .load(load1),
                .awe(awe),
                .d(d1),
                .q(q1),
                .rco(rco1)
            );


counter2 C1                                         // Instantiate Second Counter
            (
                .clock(clock),
                .reset(reset),
                .enable(enable),
                .load(load2),
                .awe(awe),
                .d(rData),
                .q(q2),
                .rco(rco2)
            );
               
endmodule